Package ghidra.program.util

# Interface ChangeManager

All Known Implementing Classes:
  `ChangeManagerAdapter`, `ProgramDB`

public interface ChangeManager
ProgramEventerface to define event types and the method to generate an event within Program.

Note: Previously (before 11.1), program change event types were defined in this file as integer constants. Event ids have since been converted to enum types. The defines in this file have been converted to point to the new enum values to make it easier to convert to this new way and to clearly see how the old values map to the new enums. In future releases, these defines will be removed.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final ProgramEvent`
  `DOCR_ADDRESS_SET_PROPERTY_MAP_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_ADDRESS_SET_PROPERTY_MAP_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_ADDRESS_SET_PROPERTY_MAP_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_BOOKMARK_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_BOOKMARK_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_BOOKMARK_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_BOOKMARK_TYPE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_BOOKMARK_TYPE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CATEGORY_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CATEGORY_MOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CATEGORY_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CATEGORY_RENAMED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_MOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_REPLACED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_UNIT_PROPERTY_ALL_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_UNIT_PROPERTY_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_CODE_UNIT_USER_DATA_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_DATA_TYPE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_DATA_TYPE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_DATA_TYPE_MOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_DATA_TYPE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_DATA_TYPE_RENAMED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_DATA_TYPE_REPLACED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_DATA_TYPE_SETTING_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EOL_COMMENT_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EQUATE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EQUATE_REFERENCE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EQUATE_REFERENCE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EQUATE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EQUATE_RENAMED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_ENTRY_POINT_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_ENTRY_POINT_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_NAME_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_NAME_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_NAME_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_PATH_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_REFERENCE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_EXTERNAL_REFERENCE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FALLTHROUGH_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FLOWOVERRIDE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FRAGMENT_MOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FUNCTION_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FUNCTION_BODY_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FUNCTION_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FUNCTION_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FUNCTION_TAG_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FUNCTION_TAG_CREATED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_FUNCTION_TAG_DELETED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_GROUP_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_GROUP_ALIAS_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_GROUP_COMMENT_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_GROUP_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_GROUP_RENAMED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_GROUP_REPARENTED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_IMAGE_BASE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_INT_ADDRESS_SET_PROPERTY_MAP_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_INT_ADDRESS_SET_PROPERTY_MAP_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_INT_ADDRESS_SET_PROPERTY_MAP_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_LANGUAGE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_LENGTH_OVERRIDE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEM_REF_PRIMARY_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEM_REF_PRIMARY_SET`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEM_REF_TYPE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEM_REFERENCE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEM_REFERENCE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEMORY_BLOCK_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEMORY_BLOCK_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEMORY_BLOCK_MOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEMORY_BLOCK_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEMORY_BLOCK_SPLIT`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEMORY_BLOCKS_JOINED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MEMORY_BYTES_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_MODULE_REORDERED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_OVERLAY_SPACE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_OVERLAY_SPACE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_OVERLAY_SPACE_RENAMED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_PLATE_COMMENT_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_POST_COMMENT_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_PRE_COMMENT_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_REGISTER_VALUES_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_REPEATABLE_COMMENT_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SOURCE_ARCHIVE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SOURCE_ARCHIVE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_ADDRESS_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_ANCHORED_FLAG_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_ASSOCIATION_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_ASSOCIATION_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_DATA_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_RENAMED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_SCOPE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_SET_AS_PRIMARY`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_SYMBOL_SOURCE_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_TREE_CREATED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_TREE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_TREE_RENAMED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_USER_DATA_CHANGED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_VARIABLE_REFERENCE_ADDED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final ProgramEvent`
  `DOCR_VARIABLE_REFERENCE_REMOVED`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final FunctionChangeRecord.FunctionChangeType`
  `FUNCTION_CHANGED_CALL_FIXUP`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final FunctionChangeRecord.FunctionChangeType`
  `FUNCTION_CHANGED_INLINE`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final FunctionChangeRecord.FunctionChangeType`
  `FUNCTION_CHANGED_NORETURN`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final FunctionChangeRecord.FunctionChangeType`
  `FUNCTION_CHANGED_PARAMETERS`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final FunctionChangeRecord.FunctionChangeType`
  `FUNCTION_CHANGED_PURGE`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final FunctionChangeRecord.FunctionChangeType`
  `FUNCTION_CHANGED_RETURN`
  Deprecated.
  Event type numeric constants have been changed to enums.
  `static final FunctionChangeRecord.FunctionChangeType`
  `FUNCTION_CHANGED_THUNK`
  Deprecated.
  Event type numeric constants have been changed to enums.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `setChanged(ProgramEvent eventType, Address start, Address end, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setChanged(ProgramEvent eventType, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setObjChanged(ProgramEvent eventType, Address addr, Object affected, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setObjChanged(ProgramEvent eventType, Object affected, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the event of the specified type.
  `void`
  `setPropertyChanged(String propertyName, Address codeUnitAddr, Object oldValue, Object newValue)`
  Mark the state of a Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_CHANGED event.
  `void`
  `setPropertyRangeRemoved(String propertyName, Address start, Address end)`
  Mark the state of the Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED event.
  `void`
  `setRegisterValuesChanged(Register register, Address start, Address end)`
  Notifies that register values have changed over the indicated address range.

- ## Field Details

  - ### DOCR_MEMORY_BLOCK_ADDED

    @Deprecated static final ProgramEvent DOCR_MEMORY_BLOCK_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A memory block was created.

  - ### DOCR_MEMORY_BLOCK_REMOVED

    @Deprecated static final ProgramEvent DOCR_MEMORY_BLOCK_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A memory block was removed.

  - ### DOCR_MEMORY_BLOCK_CHANGED

    @Deprecated static final ProgramEvent DOCR_MEMORY_BLOCK_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A memory block was changed. (for example: its name, comment, or read, write, or execute flags were changed.)

  - ### DOCR_MEMORY_BLOCK_MOVED

    @Deprecated static final ProgramEvent DOCR_MEMORY_BLOCK_MOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A block of memory was moved to a new start address.

  - ### DOCR_MEMORY_BLOCK_SPLIT

    @Deprecated static final ProgramEvent DOCR_MEMORY_BLOCK_SPLIT
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A memory block was split ProgramEvento two memory blocks.

  - ### DOCR_MEMORY_BLOCKS_JOINED

    @Deprecated static final ProgramEvent DOCR_MEMORY_BLOCKS_JOINED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Two memory blocks were joined ProgramEvento a single memory block.

  - ### DOCR_MEMORY_BYTES_CHANGED

    @Deprecated static final ProgramEvent DOCR_MEMORY_BYTES_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The bytes changed in memory.

  - ### DOCR_IMAGE_BASE_CHANGED

    @Deprecated static final ProgramEvent DOCR_IMAGE_BASE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The memory image base has changed.

  - ### DOCR_CODE_ADDED

    @Deprecated static final ProgramEvent DOCR_CODE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A CodeUnit was added. The "New Value" may be null when a block of Instructions are added

  - ### DOCR_CODE_REMOVED

    @Deprecated static final ProgramEvent DOCR_CODE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A CodeUnit was removed.

  - ### DOCR_CODE_MOVED

    @Deprecated static final ProgramEvent DOCR_CODE_MOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    CodeUnits were moved from one Fragment to another.

  - ### DOCR_CODE_REPLACED

    @Deprecated static final ProgramEvent DOCR_CODE_REPLACED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data was replaced.

  - ### DOCR_CODE_UNIT_PROPERTY_CHANGED

    @Deprecated static final ProgramEvent DOCR_CODE_UNIT_PROPERTY_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A property on a code unit was changed.

  - ### DOCR_CODE_UNIT_PROPERTY_ALL_REMOVED

    @Deprecated static final ProgramEvent DOCR_CODE_UNIT_PROPERTY_ALL_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Generated whenever an entire user property manager is deleted.

  - ### DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED

    @Deprecated static final ProgramEvent DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Property over a range of addresses was removed.

  - ### DOCR_SYMBOL_ADDED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A symbol was created.

  - ### DOCR_SYMBOL_REMOVED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A symbol was removed.

  - ### DOCR_SYMBOL_SOURCE_CHANGED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_SOURCE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The source of a symbol name was changed.

  - ### DOCR_SYMBOL_ANCHORED_FLAG_CHANGED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_ANCHORED_FLAG_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The anchor flag for the symbol was changed.

  - ### DOCR_SYMBOL_SET_AS_PRIMARY

    @Deprecated static final ProgramEvent DOCR_SYMBOL_SET_AS_PRIMARY
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A symbol was set as primary.

  - ### DOCR_SYMBOL_RENAMED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_RENAMED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A symbol was renamed.

  - ### DOCR_EXTERNAL_ENTRY_POINT_ADDED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_ENTRY_POINT_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An external entry poProgramEvent was added.

  - ### DOCR_EXTERNAL_ENTRY_POINT_REMOVED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_ENTRY_POINT_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An external entry poProgramEvent was removed.

  - ### DOCR_SYMBOL_SCOPE_CHANGED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_SCOPE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The scope on a symbol changed.

  - ### DOCR_SYMBOL_ASSOCIATION_ADDED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_ASSOCIATION_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An association to a symbol for a reference was added.

  - ### DOCR_SYMBOL_ASSOCIATION_REMOVED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_ASSOCIATION_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An association to a symbol for a reference was removed.

  - ### DOCR_SYMBOL_DATA_CHANGED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_DATA_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Symbol data changed. This corresponds to various changes within the symbol (e.g., primary status, datatype, external path or VariableStorage).

  - ### DOCR_SYMBOL_ADDRESS_CHANGED

    @Deprecated static final ProgramEvent DOCR_SYMBOL_ADDRESS_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Symbol address changed. NOTE: This is only permitted for variable/parameter symbols

  - ### DOCR_MEM_REFERENCE_ADDED

    @Deprecated static final ProgramEvent DOCR_MEM_REFERENCE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A reference was added to a symbol.

  - ### DOCR_MEM_REFERENCE_REMOVED

    @Deprecated static final ProgramEvent DOCR_MEM_REFERENCE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A reference was removed from a symbol.

  - ### DOCR_MEM_REF_TYPE_CHANGED

    @Deprecated static final ProgramEvent DOCR_MEM_REF_TYPE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The ref type on a memory reference changed.

  - ### DOCR_MEM_REF_PRIMARY_SET

    @Deprecated static final ProgramEvent DOCR_MEM_REF_PRIMARY_SET
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The reference was identified as the primary.

  - ### DOCR_MEM_REF_PRIMARY_REMOVED

    @Deprecated static final ProgramEvent DOCR_MEM_REF_PRIMARY_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The primary reference was removed.

  - ### DOCR_EXTERNAL_PATH_CHANGED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_PATH_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The external path name changed for an external program name.

  - ### DOCR_EXTERNAL_NAME_ADDED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_NAME_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An external program name was added.

  - ### DOCR_EXTERNAL_NAME_REMOVED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_NAME_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An external program name was removed.

  - ### DOCR_EXTERNAL_NAME_CHANGED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_NAME_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The name for an external program changed.

  - ### DOCR_EQUATE_ADDED

    @Deprecated static final ProgramEvent DOCR_EQUATE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An Equate was created.

  - ### DOCR_EQUATE_REMOVED

    @Deprecated static final ProgramEvent DOCR_EQUATE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An Equate was deleted.

  - ### DOCR_EQUATE_REFERENCE_ADDED

    @Deprecated static final ProgramEvent DOCR_EQUATE_REFERENCE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A reference at an operand was added to an Equate.

  - ### DOCR_EQUATE_REFERENCE_REMOVED

    @Deprecated static final ProgramEvent DOCR_EQUATE_REFERENCE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A reference at an operand was removed from an Equate.

  - ### DOCR_EQUATE_RENAMED

    @Deprecated static final ProgramEvent DOCR_EQUATE_RENAMED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An Equate was renamed.

  - ### DOCR_GROUP_ADDED

    @Deprecated static final ProgramEvent DOCR_GROUP_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A Module or Fragment was added.

  - ### DOCR_GROUP_REMOVED

    @Deprecated static final ProgramEvent DOCR_GROUP_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A Module or Fragment was removed.

  - ### DOCR_GROUP_RENAMED

    @Deprecated static final ProgramEvent DOCR_GROUP_RENAMED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A Module or Fragment was renamed.

  - ### DOCR_GROUP_COMMENT_CHANGED

    @Deprecated static final ProgramEvent DOCR_GROUP_COMMENT_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The comment for a Module or Fragment changed.

  - ### DOCR_GROUP_ALIAS_CHANGED

    @Deprecated static final ProgramEvent DOCR_GROUP_ALIAS_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The alias for a Module or Fragment changed.

  - ### DOCR_MODULE_REORDERED

    @Deprecated static final ProgramEvent DOCR_MODULE_REORDERED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The children of a Module have been reordered.

  - ### DOCR_FRAGMENT_MOVED

    @Deprecated static final ProgramEvent DOCR_FRAGMENT_MOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Fragment or set of fragments have been moved.

  - ### DOCR_GROUP_REPARENTED

    @Deprecated static final ProgramEvent DOCR_GROUP_REPARENTED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Group was reparented.

  - ### DOCR_EOL_COMMENT_CHANGED

    @Deprecated static final ProgramEvent DOCR_EOL_COMMENT_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The end-of-line comment changed for a CodeUnit.

  - ### DOCR_PRE_COMMENT_CHANGED

    @Deprecated static final ProgramEvent DOCR_PRE_COMMENT_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The pre comment changed for a CodeUnit.

  - ### DOCR_POST_COMMENT_CHANGED

    @Deprecated static final ProgramEvent DOCR_POST_COMMENT_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The post comment changed for a CodeUnit.

  - ### DOCR_PLATE_COMMENT_CHANGED

    @Deprecated static final ProgramEvent DOCR_PLATE_COMMENT_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A Plate comment was added, deleted, or changed.

  - ### DOCR_REPEATABLE_COMMENT_CHANGED

    @Deprecated static final ProgramEvent DOCR_REPEATABLE_COMMENT_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A Repeatable Comment changed.

  - ### DOCR_CATEGORY_ADDED

    @Deprecated static final ProgramEvent DOCR_CATEGORY_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Category was added.

  - ### DOCR_CATEGORY_REMOVED

    @Deprecated static final ProgramEvent DOCR_CATEGORY_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Category was removed.

  - ### DOCR_CATEGORY_RENAMED

    @Deprecated static final ProgramEvent DOCR_CATEGORY_RENAMED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Category was renamed.

  - ### DOCR_CATEGORY_MOVED

    @Deprecated static final ProgramEvent DOCR_CATEGORY_MOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Category was moved.

  - ### DOCR_DATA_TYPE_ADDED

    @Deprecated static final ProgramEvent DOCR_DATA_TYPE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data type was added to a category.

  - ### DOCR_DATA_TYPE_REMOVED

    @Deprecated static final ProgramEvent DOCR_DATA_TYPE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data type was removed from a category.

  - ### DOCR_DATA_TYPE_RENAMED

    @Deprecated static final ProgramEvent DOCR_DATA_TYPE_RENAMED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data Type was renamed.

  - ### DOCR_DATA_TYPE_MOVED

    @Deprecated static final ProgramEvent DOCR_DATA_TYPE_MOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data type was moved to another category.

  - ### DOCR_DATA_TYPE_CHANGED

    @Deprecated static final ProgramEvent DOCR_DATA_TYPE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data type was updated.

  - ### DOCR_DATA_TYPE_SETTING_CHANGED

    @Deprecated static final ProgramEvent DOCR_DATA_TYPE_SETTING_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The settings on a data type were updated.

  - ### DOCR_DATA_TYPE_REPLACED

    @Deprecated static final ProgramEvent DOCR_DATA_TYPE_REPLACED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data type was replaced in a category.

  - ### DOCR_SOURCE_ARCHIVE_ADDED

    @Deprecated static final ProgramEvent DOCR_SOURCE_ARCHIVE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data type was added to a category.

  - ### DOCR_SOURCE_ARCHIVE_CHANGED

    @Deprecated static final ProgramEvent DOCR_SOURCE_ARCHIVE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Data type was updated.

  - ### DOCR_BOOKMARK_TYPE_ADDED

    @Deprecated static final ProgramEvent DOCR_BOOKMARK_TYPE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Bookmark type was added.

  - ### DOCR_BOOKMARK_TYPE_REMOVED

    @Deprecated static final ProgramEvent DOCR_BOOKMARK_TYPE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Bookmark type was removed.

  - ### DOCR_BOOKMARK_ADDED

    @Deprecated static final ProgramEvent DOCR_BOOKMARK_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Bookmark was added.

  - ### DOCR_BOOKMARK_REMOVED

    @Deprecated static final ProgramEvent DOCR_BOOKMARK_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Bookmark was deleted.

  - ### DOCR_BOOKMARK_CHANGED

    @Deprecated static final ProgramEvent DOCR_BOOKMARK_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Bookmark category or comment was changed (old value not provided).

  - ### DOCR_LANGUAGE_CHANGED

    @Deprecated static final ProgramEvent DOCR_LANGUAGE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The language for the Program changed.

  - ### DOCR_REGISTER_VALUES_CHANGED

    @Deprecated static final ProgramEvent DOCR_REGISTER_VALUES_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Register values changed.

  - ### DOCR_OVERLAY_SPACE_ADDED

    @Deprecated static final ProgramEvent DOCR_OVERLAY_SPACE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An overlay address space was added.

  - ### DOCR_OVERLAY_SPACE_REMOVED

    @Deprecated static final ProgramEvent DOCR_OVERLAY_SPACE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An overlay address space was removed.

  - ### DOCR_OVERLAY_SPACE_RENAMED

    @Deprecated static final ProgramEvent DOCR_OVERLAY_SPACE_RENAMED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An overlay address space was renamed.

  - ### DOCR_TREE_CREATED

    @Deprecated static final ProgramEvent DOCR_TREE_CREATED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Tree was created.

  - ### DOCR_TREE_REMOVED

    @Deprecated static final ProgramEvent DOCR_TREE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Tree was removed.

  - ### DOCR_TREE_RENAMED

    @Deprecated static final ProgramEvent DOCR_TREE_RENAMED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Tree was renamed.

  - ### DOCR_FUNCTION_TAG_CHANGED

    @Deprecated static final ProgramEvent DOCR_FUNCTION_TAG_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function tag was edited

  - ### DOCR_FUNCTION_TAG_CREATED

    @Deprecated static final ProgramEvent DOCR_FUNCTION_TAG_CREATED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function tag was created

  - ### DOCR_FUNCTION_TAG_DELETED

    @Deprecated static final ProgramEvent DOCR_FUNCTION_TAG_DELETED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function tag was created

  - ### DOCR_FUNCTION_ADDED

    @Deprecated static final ProgramEvent DOCR_FUNCTION_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Function was added.

  - ### DOCR_FUNCTION_REMOVED

    @Deprecated static final ProgramEvent DOCR_FUNCTION_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Function was removed.

  - ### DOCR_FUNCTION_CHANGED

    @Deprecated static final ProgramEvent DOCR_FUNCTION_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    Function was changed.

  - ### DOCR_VARIABLE_REFERENCE_ADDED

    @Deprecated static final ProgramEvent DOCR_VARIABLE_REFERENCE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function variable reference was added.

  - ### DOCR_VARIABLE_REFERENCE_REMOVED

    @Deprecated static final ProgramEvent DOCR_VARIABLE_REFERENCE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function variable reference was removed.

  - ### DOCR_FUNCTION_BODY_CHANGED

    @Deprecated static final ProgramEvent DOCR_FUNCTION_BODY_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function's body changed.

  - ### FUNCTION_CHANGED_PURGE

    @Deprecated static final FunctionChangeRecord.FunctionChangeType FUNCTION_CHANGED_PURGE
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function's purge size was changed.

  - ### FUNCTION_CHANGED_INLINE

    @Deprecated static final FunctionChangeRecord.FunctionChangeType FUNCTION_CHANGED_INLINE
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function's inline state was changed.

  - ### FUNCTION_CHANGED_NORETURN

    @Deprecated static final FunctionChangeRecord.FunctionChangeType FUNCTION_CHANGED_NORETURN
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function's no-return state was changed.

  - ### FUNCTION_CHANGED_CALL_FIXUP

    @Deprecated static final FunctionChangeRecord.FunctionChangeType FUNCTION_CHANGED_CALL_FIXUP
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A function's call-fixup state was changed.

  - ### FUNCTION_CHANGED_RETURN

    @Deprecated static final FunctionChangeRecord.FunctionChangeType FUNCTION_CHANGED_RETURN
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A functions return type/storage was modified

  - ### FUNCTION_CHANGED_PARAMETERS

    @Deprecated static final FunctionChangeRecord.FunctionChangeType FUNCTION_CHANGED_PARAMETERS
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A functions parameter list was modified

  - ### FUNCTION_CHANGED_THUNK

    @Deprecated static final FunctionChangeRecord.FunctionChangeType FUNCTION_CHANGED_THUNK
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A functions thunk status has changed

  - ### DOCR_EXTERNAL_REFERENCE_ADDED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_REFERENCE_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An external reference was added.

  - ### DOCR_EXTERNAL_REFERENCE_REMOVED

    @Deprecated static final ProgramEvent DOCR_EXTERNAL_REFERENCE_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An external reference was removed.

  - ### DOCR_FALLTHROUGH_CHANGED

    @Deprecated static final ProgramEvent DOCR_FALLTHROUGH_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    A Fallthrough address was changed for an instruction.

  - ### DOCR_FLOWOVERRIDE_CHANGED

    @Deprecated static final ProgramEvent DOCR_FLOWOVERRIDE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    The flow override for an instruction has changed.

  - ### DOCR_LENGTH_OVERRIDE_CHANGED

    @Deprecated static final ProgramEvent DOCR_LENGTH_OVERRIDE_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An instruction length override was changed for an instruction.

  - ### DOCR_ADDRESS_SET_PROPERTY_MAP_ADDED

    @Deprecated static final ProgramEvent DOCR_ADDRESS_SET_PROPERTY_MAP_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An AddressSetPropertyMap was added.

  - ### DOCR_ADDRESS_SET_PROPERTY_MAP_REMOVED

    @Deprecated static final ProgramEvent DOCR_ADDRESS_SET_PROPERTY_MAP_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An AddressSetPropertyMap was removed.

  - ### DOCR_ADDRESS_SET_PROPERTY_MAP_CHANGED

    @Deprecated static final ProgramEvent DOCR_ADDRESS_SET_PROPERTY_MAP_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An AddressSetPropertyMap was changed.

  - ### DOCR_INT_ADDRESS_SET_PROPERTY_MAP_ADDED

    @Deprecated static final ProgramEvent DOCR_INT_ADDRESS_SET_PROPERTY_MAP_ADDED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An ProgramEventAddressSetPropertyMap was added.

  - ### DOCR_INT_ADDRESS_SET_PROPERTY_MAP_REMOVED

    @Deprecated static final ProgramEvent DOCR_INT_ADDRESS_SET_PROPERTY_MAP_REMOVED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An ProgramEventAddressSetPropertyMap was removed.

  - ### DOCR_INT_ADDRESS_SET_PROPERTY_MAP_CHANGED

    @Deprecated static final ProgramEvent DOCR_INT_ADDRESS_SET_PROPERTY_MAP_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    An ProgramEventAddressSetPropertyMap was changed.

  - ### DOCR_CODE_UNIT_USER_DATA_CHANGED

    @Deprecated static final ProgramEvent DOCR_CODE_UNIT_USER_DATA_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    User Data for a code unit changed

  - ### DOCR_USER_DATA_CHANGED

    @Deprecated static final ProgramEvent DOCR_USER_DATA_CHANGED
    Deprecated.
    Event type numeric constants have been changed to enums. Use the enum directly.
    User Data changed

- ## Method Details

  - ### setChanged

    void setChanged(ProgramEvent eventType, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `eventType` - the event type
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setRegisterValuesChanged

    void setRegisterValuesChanged(Register register, Address start, Address end)
    Notifies that register values have changed over the indicated address range.
    Parameters:
      `register` - register value which was modified (a value of null indicates all registers affected or unknown)
      `start` - the start address for the range where values changed
      `end` - the end address (inclusive) for the range where values changed

  - ### setChanged

    void setChanged(ProgramEvent eventType, Address start, Address end, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `eventType` - the event type
      `start` - starting address that is affected by the event
      `end` - ending address that is affected by the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setObjChanged

    void setObjChanged(ProgramEvent eventType, Object affected, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `eventType` - the event type
      `affected` - object that is the subject of the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setObjChanged

    void setObjChanged(ProgramEvent eventType, Address addr, Object affected, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the event of the specified type. Any or all parameters may be null.
    Parameters:
      `eventType` - the event type
      `addr` - program address affected
      `affected` - object that is the subject of the event
      `oldValue` - original value or an Object that is related to the event
      `newValue` - new value or an Object that is related to the the event

  - ### setPropertyChanged

    void setPropertyChanged(String propertyName, Address codeUnitAddr, Object oldValue, Object newValue)
    Mark the state of a Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_CHANGED event.
    Parameters:
      `propertyName` - name of property for the range that changed
      `codeUnitAddr` - address of the code unit with the property change
      `oldValue` - old value for the property
      `newValue` - new value for the property

  - ### setPropertyRangeRemoved

    void setPropertyRangeRemoved(String propertyName, Address start, Address end)
    Mark the state of the Program as having changed and generate the DOCR_CODE_UNIT_PROPERTY_RANGE_REMOVED event.
    Parameters:
      `propertyName` - name of property for the range being removed
      `start` - start address of the range
      `end` - end address of the range